#ifndef NETTLE_SM4_H_INCLUDED
#define NETTLE_SM4_H_INCLUDED

#include "nettle-types.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Name mangling */
#define sm4_set_key nettle_sm4_set_key
#define sm4128_set_key nettle_sm4128_set_key
#define sm4_encrypt nettle_sm4_encrypt
#define sm4_decrypt nettle_sm4_decrypt

#define SM4_BLOCK_SIZE 16

/* Variable key size is 128 */
#define SM4_MIN_KEY_SIZE 16
#define SM4_MAX_KEY_SIZE 16

#define SM4_KEY_SIZE 16
#define SM4128_KEY_SIZE 16

struct sm4_ctx
{
  uint32_t rk[32];
};



void
sm4_set_key(struct sm4_ctx *ctx, const uint8_t *key);
void
sm4128_set_key(struct sm4_ctx *context, const uint8_t *key);

void
sm4_encrypt(const struct sm4_ctx *ctx,
		size_t length, uint8_t *dst,
		const uint8_t *src);
void
sm4_decrypt(const struct sm4_ctx *ctx,
		size_t length, uint8_t *dst,
		const uint8_t *src);

#ifdef __cplusplus
}
#endif

#endif /* NETTLE_SM4_H_INCLUDED */
